(* ------------------------------------------------------------------------ *)
(* ------------------ MDULO DE IMPLEMENTACIN.  CADENAS ------------------ *)
(* ------------------------------------------------------------------------ *)

IMPLEMENTATION MODULE cadenas;


(* Longitud de dos cadenas de carcteres. *)
PROCEDURE Longitud(cad:ARRAY OF CHAR):CARDINAL;
VAR
  i:CARDINAL;
BEGIN
  i:=0;
  WHILE (i<=HIGH(cad)) AND (cad[i]<>terminador) DO
    INC(i);
  END;
  RETURN(i);
END Longitud;


(* Comparar dos cadenas de carcteres. Devuelve TRUE si son iguales. *)
PROCEDURE Comparar(cad1,cad2:ARRAY OF CHAR):BOOLEAN;
VAR
  iguales:BOOLEAN;
  i:CARDINAL;
BEGIN
  iguales:=TRUE;
  i:=0;
  IF Longitud(cad1)=Longitud(cad2) THEN
    WHILE (i<=HIGH(cad1)) AND (cad1[i]<>terminador) AND (iguales) DO
      IF CAP(cad1[i])=CAP(cad2[i]) THEN
        i:=i+1;
      ELSE
        iguales:=FALSE;
      END;
    END;
  ELSE
    iguales:=FALSE;
  END;
  RETURN(iguales);
END Comparar;



PROCEDURE Copiar(VAR cad1:ARRAY OF CHAR; cad2:ARRAY OF CHAR);
VAR
  i:CARDINAL;
BEGIN
    i:=0;
    WHILE (i<=HIGH(cad1)) AND (i<=HIGH(cad2)) AND (cad2[i]<>terminador) DO
          cad1[i]:=cad2[i];
          INC(i);
    END;
    IF i<=HIGH(cad1) THEN
       cad1[i]:=terminador;
    END;
END Copiar;


END cadenas.


