(* ----------------------------------------------------------------------- *)
(* --------------------------- MDULO PRINCIPAL -------------------------- *)
(* ----------------------------------------------------------------------- *)
(* Practica del videoClub                                                  *)

MODULE menu;


IMPORT IO;
FROM Window IMPORT Clear;
FROM videocl IMPORT TError,TVideo, CrearEstructura, NuevoSocio,
                    NuevaPelicula,Alquila,Devuelve,Visualizar,Destruir,
                    VolcarTexto,Regalo,FichATAD;

CONST
  MaxCad=50;


TYPE
  TCadena=ARRAY[1..MaxCad] OF CHAR;


VAR
  opcion:CHAR;                  (* Opcin elegida en el men. *)
  fin:BOOLEAN;                  (* Fin del programa. *)
  bas:CHAR;                     (* Pausas en el programa. *)
  video:TVideo;                 (* Variable principal. *)
  error: TError;                (* Error producido en cada monento. *)




(* -------------- ZONA DE SUBALGORITMOS ----------------- *)


(* Muestra el men en pantalla y lee una opcin. *)
PROCEDURE MostrarMenu(VAR opcion:CHAR);
BEGIN
  IO.WrLn;
  IO.WrStr(" --- GESTIN DE VIDEOCLUB --- ");
  IO.WrLn;
  IO.WrLn;
  IO.WrStr("A.- Aadir un socio. ");
  IO.WrLn;
  IO.WrStr("B.- Aadir una pelcula. ");
  IO.WrLn;
  IO.WrStr("C.- Alquilar una pelcula. ");
  IO.WrLn;
  IO.WrStr("D.- Devolver una pelcula. ");
  IO.WrLn;
  IO.WrStr("E.- Visualizar el TAD en la pantalla. ");
  IO.WrLn;
  IO.WrStr("F.- Volcar la lista de clientes a un fichero de texto. ");
  IO.WrLn;
  IO.WrStr("G.- Regalo para los clientes. ");
  IO.WrLn;
  IO.WrStr("H.- Crear video Club desde el fichero. ");
  IO.WrLn;
  IO.WrStr("X.- Salir. ");
  IO.WrLn; IO.WrLn; IO.RdLn;
  IO.WrStr("Opcin: ");
  opcion:=CAP(IO.RdChar());
END MostrarMenu;

PROCEDURE pausa();
BEGIN
      IO.WrLn; IO.RdLn;
      IO.WrStr("Pulse tecla para continuar");
      REPEAT UNTIL IO.KeyPressed();
END pausa;


(* Imprime los errores en pantalla. *)
PROCEDURE VerError(error:TError);
BEGIN
  CASE error OF
    Bien : |
    YaExisteEstructura : IO.WrStr("Error. Ya exista la estructura. ");
                         pausa |
    NoHayEspacio : IO.WrStr("Error. No hay suficiente espacio en memoria. ");
                         pausa |
    EstructuraNoCreada : IO.WrStr("Error. La estructura no ha sido creada. Ejecute R para crearla. ");
                         pausa |
    SocioYaExiste : IO.WrStr("Error. El socio ya existe. ");
                         pausa |
    SocioNoExiste : IO.WrStr("Error. El socio introducido no existe. ");
                         pausa |
    PeliculaNoExiste : IO.WrStr("Error. La pelcula introducida no existe. ");
                         pausa |
    PeliculaAgotada : IO.WrStr("Error. No hay ms copias de la pelcula. ");
                         pausa |
    AlquilerNoExiste : IO.WrStr("Error. El usuario introducido no ha alquilado esta pelcula. ");
                         pausa |
    NoHay : IO.WrStr("Error. La estrurcura no haba sido creada. ");
                         pausa |
    NadieAlquila : IO.WrStr("Error. Nadie tiene alquilada esta pelcula. ");
                         pausa
  END;
END VerError;


(* OPCION A. Aadir un socio nuevo a la estructura. *)
PROCEDURE AnadirSocio(VAR video:TVideo; VAR error:TError);
VAR
  bas:CHAR;
  nombre,telefono,direccion:TCadena;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("A.- Aadir un socio nuevo a la estructura. ");
  IO.WrLn; IO.RdLn;
  IO.WrStr("Nombre: ");
  IO.RdStr(nombre);
  IO.WrStr("Telfono: ");
  IO.RdStr(telefono);
  IO.WrStr("Direccin: ");
  IO.RdStr(direccion);
  IO.WrLn; IO.RdLn;
  NuevoSocio(video,error,nombre,telefono,direccion);
END AnadirSocio;



(* Opcion B. Aadir una pelcula nueva a la estructura. *)
PROCEDURE AnadirPelicula(VAR video:TVideo; VAR error:TError);
VAR
  titulo:TCadena;
  copias:CARDINAL;
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("B.- Aadir pelcula al catlogo. ");
  IO.WrLn;
  IO.WrStr("Ttulo: ");
  IO.RdStr(titulo);
  REPEAT
    IO.WrStr("N de copias: "); IO.RdLn;
    copias:=IO.RdCard();
  UNTIL copias>0;
  IO.WrLn; IO.RdLn;
  NuevaPelicula(video,error,titulo,copias);
END AnadirPelicula;



(* Opcion C. Alquiler de una pelcula. *)
PROCEDURE Alquilar(VAR video:TVideo; VAR error:TError);
VAR
  titulo:TCadena;
  numero:CARDINAL;
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("C.- Alquilar una pelcula. ");
  IO.WrLn; IO.RdLn;
  IO.WrStr("Nmero de socio: ");
  numero:=IO.RdCard();
  IO.WrLn;
  IO.WrStr("Ttulo a alquilar: ");
  IO.RdStr(titulo);
  IO.WrLn;
  Alquila(video,error,numero,titulo);
END Alquilar;



(* Opcin D. Devolucin de una pelcula. *)
PROCEDURE Devolver(VAR video:TVideo; VAR error:TError);
VAR
  numero:CARDINAL;
  titulo:TCadena;
  dias:CARDINAL;
  pagar:CARDINAL;
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("D.- Devolver una pelcula. ");
  IO.WrLn;
  IO.WrStr("Nmero de socio: ");
  numero:=IO.RdCard();
  IO.RdLn;
  IO.WrStr("Ttulo de la pelcula: ");
  IO.RdStr(titulo);
  IO.WrStr("Dias de alquiler: ");
  dias:=IO.RdCard();
  pagar:=0;
  Devuelve(video,error,numero,titulo,dias,pagar);
  IO.WrLn;
  IO.WrStr("Total a pagar: ");
  IO.WrCard(pagar,0);
  IO.WrStr(" pts.");
END Devolver;



(* Opcin E. Visualizar todos los datos en pantalla. *)
PROCEDURE Imprimir(video:TVideo; VAR error:TError);
VAR
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("Visualizando TAD ");
  IO.WrLn; IO.RdLn;
  Visualizar(video,error);
END Imprimir;



(* Opcin F. Guardar los datos del videoclub en fichero "video.dat") *)
PROCEDURE Grabar(video:TVideo; VAR error:TError);
VAR
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  VolcarTexto(video,error)
END Grabar;


(* Opcin H. Regalar una pelcula. *)
PROCEDURE Regalar(VAR video:TVideo; VAR error:TError);
VAR
  titulo:TCadena;
  bas:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;
  IO.WrStr("Ttulo a regalar: ");
  IO.RdStr(titulo);
  IO.WrLn; IO.RdLn;
  Regalo(video,error,titulo);
END Regalar;



(* Opcin X. Terminar la ejecucin del programa. *)
PROCEDURE Terminar(VAR fin:BOOLEAN);
VAR
  seguro:CHAR;
BEGIN
  IO.WrLn; IO.WrLn;IO. RdLn;
  IO.WrStr("Est seguro que desea salir? (S/N): ");
  seguro:=CAP(IO.RdChar());
  IF seguro="S" THEN
    fin:=TRUE;
  END;
END Terminar;


(* ----------------------- PROGRAMA PRINCIPAL ---------------------------- *)
BEGIN
  fin:=FALSE;
  CrearEstructura(video,error);
  REPEAT
    error:=Bien;
    MostrarMenu(opcion);
    CASE opcion OF
      "A" : AnadirSocio(video,error); |
      "B" : AnadirPelicula(video,error); |
      "C" : Alquilar(video,error); |
      "D" : Devolver(video,error); |
      "E" : Imprimir(video,error); |
      "F" : Grabar(video,error); |
      "G" : Regalar(video,error); |
      "H" : FichATAD(video,error); |
      "X" : Terminar(fin);
    ELSE
      IO.WrLn; IO.WrLn; IO.RdLn;
      IO.WrStr("Opcin incorrecta o no implementada. ");
    END;
    IF opcion<>"X" THEN
      IO.WrLn; IO.WrLn;
      VerError(error);
    END;
  UNTIL fin;
  Clear;
  Destruir(video,error);
  VerError(error);
  IO.WrLn; IO.WrLn;
  IO.WrStr("Hasta luego. No se te olvide visitar ");IO.WrLn;
  IO.WrStr("    http://www.lcc.uma.es/~afdez/apuntes. "); IO.WrLn;
  IO.WrStr("Para coger apuntes, practicas y juegos hechos en Modula-2 ");IO.WrLn;
  IO.WrLn;
  IO.WrStr("Hasta otra..........:-) ");
END menu.


